


import processing.serial.*;


int bgcolor;           // Background color
int fgcolor;           // Fill color
Serial myPort;                       // The serial port
int[] serialInArray = new int[3];    // Where we'll put what we receive
int serialCount = 0;                 // A count of how many bytes we receive
int xpos, ypos;                 // Starting position of the ball
boolean firstContact = false;        // Whether we've heard from the microcontroller



char TIMEOUT = 1;
char END = 192;
char ESCAPE = 219;
char ESCAPE_END = 220;
char ESCAPE_ESCAPE = 221;



//Address of this computer
int soutsource1=10; // source address byte 1
   int soutsource2=0; // source address byte 2
  int soutsource3=0; // source address byte 3
 int soutsource4=1; // source address byte 4
 
 //Address of the node I want to talk to
  int soutdest1=10; // destination address byte 1
  int soutdest2=0; // destination address byte 2
 int soutdest3=0; // destination address byte 3
int soutdest4=2; // destination address byte 4
   //
   // UDP
   //
   int soutsourceport = 1234;
  int soutsourceport1=(soutsourceport & 0xFF); // source port high byte
  int soutsourceport2=((soutsourceport >> 8) & 0xFF); // source port low byte
  
  int soutdestport = 1234;
  int soutdestport1=(soutdestport & 0xFF); // destination port high byte
  int soutdestport2= ((soutdestport >> 8) & 0xFF); //destination port low byte


void setup() {
  size(256, 256);  // Stage size
  noStroke();      // No border on the next thing drawn

  // Set the starting position of the ball (middle of the stage)
  xpos = width/2;
  ypos = height/2;

  // Print a list of the serial ports, for debugging purposes:
  printArray(Serial.list());

  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);
}

void draw() {
  
}


   int high(int value){
     return (value & 0xFF);
   }
   
   int low( int value){
     return ((value >> 8) & 0xFF);
   }





void serialEvent(Serial myPort) {
  // read a byte from the serial port:
  int inByte = myPort.read();
print(inByte);
//      myPort.clear();          // clear the serial port buffer
//      myPort.write('A');       // ask for more
}








void put_packet(){


  String packet = new String();
  
  //
   // send packet
   //
   char ip_header_size = 20;
   char udp_header_size = 8;
   char outgoing_data_size = 10;

   //
   // IP
   //
   packet+="E"; //0x45 version = 4, header length = 5 32-bit words
   packet+=(0); // type of service
      
   packet+=high((ip_header_size + udp_header_size + outgoing_data_size)); // packet length
   
   
    packet+=low((ip_header_size + udp_header_size + outgoing_data_size)); // packet length
   
   
   packet+=(0); // identification high byte
   packet+=(0); // identification low byte
   packet+=(0); // flag, fragment offset high byte
   packet+=(0); // flag, fragment offset low byte
   packet+=(255); // time to live
   packet+=(17); // protocol = 17 for UDP
   packet+=(0); // header checksum high byte
   packet+=(0); // header checksum low byte
   packet+=soutsource1; // source address byte 1
   packet+=soutsource2; // source address byte 2
   packet+=soutsource3; // source address byte 3
   packet+=soutsource4; // source address byte 4
   packet+=soutdest1; // destination address byte 1
   packet+=soutdest2; // destination address byte 2
   packet+=soutdest3; // destination address byte 3
   packet+=soutdest4; // destination address byte 4
   
   
   
   //
   // UDP
   //
   packet+=soutsourceport1; // source port
   packet+=soutsourceport2; // source port
   packet+=soutdestport1; // destination port
   packet+=soutdestport2; // destination port
   
   
   
    packet+=high((udp_header_size + outgoing_data_size)); // payload length
  
     packet+=low((udp_header_size + outgoing_data_size)); // payload length
 
   
   packet+=(0); // payload checksum (not used)
   packet+=(0); // payload checksum (not used)
   //
   // data
   //
   String data = "off";
      packet+=(data);
      
      
      
       //
   // calculate checksum
   //
   /*
   todo:
   ldi zh, high(outgoing_ip_start)
   ldi zl, low(outgoing_ip_start)
   ldi count, ip_header_size
   clr check_lo
   clr check_hi
   clr check_carry
   ip_checksum_loop:
      adiw zl, 1
      ld temp, z
      dec count
      sbiw zl, 1
      ld temp1, z
      add check_lo, temp
      adc check_hi, temp1
      adc check_carry, zero
      adiw zl, 2
      dec count
      brne ip_checksum_loop
   add check_lo, check_carry
   adc check_hi, zero
   com check_lo
   com check_hi
   sts outgoing_ip_checksum, check_hi
   sts outgoing_ip_checksum+1, check_lo
 */
   //
   // send the packet with SLIP mapping and framing
   //
   
         myPort.write(END);

   for (int i=0; i< packet.length();i++)
      if (packet.charAt(i) == END)
      {
         myPort.write(ESCAPE);
         myPort.write(ESCAPE_END);
}
      else if (packet.charAt(i) == ESCAPE){
         myPort.write(ESCAPE);
         myPort.write(ESCAPE_ESCAPE);
      }
      else
         myPort.write(packet.charAt(i));
    
    myPort.write(END);

}
